#include "colors.inc"
#include "stones.inc"         
#include "woods.inc"

/*
 * Chess Board - Copyright Stefan Runkel 2005 
 */


camera {
  location <0,20,-40>
  look_at <-1,8,-25>
 }
                  
                  
 light_source {
    <100,400,-1000>, rgb <1,1,1> 
 }              

union{
  plane {y,-1}   
  plane {z,300}
  pigment {color <.6,.8,.6>}                          
}
                            
#declare bauer = object{  
  merge {
    lathe { cubic_spline 16, <0, 0>, <2, 0>, <2, .5>, <1.5, 1>, <1.8, 1.5>, <1,2>, <.65,4.5>, <.8,4.5>, <.8,4.6>, <.7,4.65>,<.8,4.7>, <.8,4.75>,<.6,4.8>,<.5,5>,<0,6>,<0,0> }
    sphere {<0,6,0>,1}
  }   
  scale 0.5
}   
              
              
             
#declare laeufer = object{  
  merge {
    lathe { cubic_spline 16, <0, 0>, <2, 0>, <2, .5>, <1.5, 1>, <1.8, 1.5>, <1,2>, <.65,4.5>, <1,4.5>, <1,4.6>, <.7,4.65>,<1,4.7>, <1,4.8>,<.4,5>,<.4,5.1>,<0,6>,<0,0> }
    difference { sphere {<0,0,0>,1 scale y*2} box{<-.1,0,-1>,<.1,3,1> rotate z*15} translate y*6.5 }
  }        
  rotate y*-45
  scale 0.5
}   


#declare springer = union {
   lathe {                          // The foot
   	cubic_spline
   	15,
   	< 0.000000, 0.925991>,
   	< 0.000000, 0.925991>,
   	< 0.353432, 0.996678>,
   	< 0.565491, 0.925991>,
   	< 0.636177, 0.784618>,
   	< 0.636177, 0.572559>,
   	< 0.706863, 0.501873>,
   	< 0.636177, 0.431187>,
   	< 0.565491, 0.360500>,
   	< 0.777550, 0.289814>,
   	< 0.636177, 0.219128>,
   	< 0.777550, 0.148441>,
   	< 0.848236, 0.007069>,
   	< 0.000000, 0.007069>,
   	< 0.000000, 0.007069>
   	scale 0.5
   }
   difference {                    // The head
      prism {
      	cubic_spline
      	0,
      	1,
      	26,
      	< 0.900127, 0.016366>,
      	< 0.981957, 0.016366>,
      	< 1.104701, 0.016366>,
      	< 1.227446, 0.261855>,
      	< 1.063786, 0.343685>,
      	< 0.981957, 0.466429>,
      	< 1.022871, 0.589174>,
      	< 1.186531, 0.589174>,
      	< 1.186531, 0.630089>,
      	< 1.227446, 0.671004>,
      	< 1.227446, 0.711918>,
      	< 1.145616, 0.752833>,
      	< 1.022871, 0.834663>,
      	< 0.981957, 0.875578>,
      	< 0.941042, 0.998322>,
      	< 0.900127, 0.875578>,
      	< 0.818297, 0.834663>,
      	< 0.736467, 0.711918>,
      	< 0.695553, 0.507344>,
      	< 0.736467, 0.220940>,
      	< 0.777382, 0.057281>,
      	< 0.818297, 0.016366>,
      	< 0.859212, 0.016366>,
      	< 0.900127, 0.016366>,
      	< 0.981957, 0.016366>,
      	< 1.104701, 0.016366>
      	rotate <-90, 0, 0>
      	translate <-1, 0.45, 0.5>
      	scale < 1, 1, 0.4>
      }
 
      box {                        // The back
         <-1, 0, 0.2>, < 1, 2, 1>
         rotate <-3,-10, 0>
      }  
      
      box {
         <-1, 0,-0.2>, < 1, 2,-1>
         rotate < 3, 10, 0>
      } 
      
      cylinder {                   // The front
         < 0, 0, 0>, < 0, 0,-1>, 1
         rotate < 0,-10, 0>
         translate < 0.86, 1.1, 0.056>
      }
      cylinder {
         < 0, 0, 0>, < 0, 0, 1>, 1
         rotate < 0, 10, 0>
         translate < 0.86, 1.1,-0.056>
      }
      box {                        // Split the ears
         -0.25,0.25
         rotate < 45, 0, 0>
         scale < 1, 1, 0.6>
         translate < 0, 1.65, 0>
      }
      cylinder {                   // The eyes
         < 0, 0, 0>, < 0, 1, 0>, 0.05
         scale < 2, 1, 0.5>
         rotate < 45, 0, 0>
         translate < 0.15, 1,-0.32>
      }
      cylinder {
         < 0, 0, 0>, < 0, 1, 0>, 0.05
         scale < 2, 1, 0.5>
         rotate <-45, 0, 0>
         translate < 0.15, 1, 0.32>
      }
      
      scale 1.2
      translate < 0,-0.1, 0>
   }             
   scale 2.4
}

 
#declare dame = object{       
  merge{
  difference {
    lathe {                             
       cubic_spline 26, <0, 0>, <2, 0>, <2, .5>, <1.5, 1>, <1.8, 1.5>, <1,2>, 
                        <.65,4>,<1.5,4>,<1.5,4.3>,<0.65,4.3>,                                   // Ring gross mitte
                        <.65,4.5>, <.8,4.5>, <.8,4.6>, <.7,4.65>,<.8,4.7>, <.8,4.75>,<.6,4.8>,  // Ringe klein
                        <.5,5>, <1,5.2>, <1.4,5.4>,<1.4,5.6>,<1,5.8>,<0.5,5.95>,<.2,6>,
                        <0,6>,<0,0> scale <.8,1,.8>
    }                                  
    
    #declare st=0;
    #while (st<6) 
       cylinder {<1.5,6.5,0>,<1.1,5,0>,0.2 rotate y* (30*st)}
       #declare st=st+1;
    #end
    
    cylinder {<0,6,0>, <0,7,0>, 2}
  }
  sphere {<0, 5.9,0>, 0.3}     
  }                  
  scale 0.8
}        

         
#declare king = object{       
  merge{
  difference {
    lathe { 
       cubic_spline 31, <0, 0>, <2, 0>, <2, .5>, <1.5, 1>, <1.8, 1.5>, <1,2>, 
                        <.65,4>,<1.5,4>,<1.5,4.3>,<0.65,4.3>,                   // Ring gross mitte
                        <.65,4.5>, <.8,4.5>, <.8,4.6>, <.7,4.65>,<.8,4.7>, <.8,4.75>,<.6,4.8>,  // Ringe klein
                        <.5,4.81>, <1,4.9>, <1.4,5.2>,<1.4,5.6>,<1,5.8>,<0.5,5.95>,<.2,6>,
                        <0.2,6.2>,<0.5,6.2>,<0.5,6.4>, <0.2,6.4>,<0.2,6.6>   
                        <0,6.6>,<0,0> scale <.8,1,.8>
    }    
    box {<-0.2,6,-1>,<-1,7,1>}
    box {< 0.2,6,-1>,< 1,7,1>}
    cylinder {<0,6.6,0>, <0,8,0>, 2}                            
  }
  sphere {<0, 6.6,0>, 0.16}  
  }                  
  scale 0.8  rotate y*45
}    
 
#declare turm = object{  
  difference{
    lathe { cubic_spline 13, <0, 0>, <2, 0>, <2, .5>, <1.5, 1>, <1.8, 1.5>, <1,4>, <1.0,4>, <1.5,4.5>, <1.8,6>,<1.6,6>,<1.6,5.5>,<0,5.5>,<0,0> }
    cylinder {<-2.2,6,0>,<2.2,6,0>,.4}
    cylinder {<0,6,-2.2>,<0,6,2.2>,.4}
  }   
  scale 0.5
}

#declare quadro = object{
  union{
    box{<-4,0,-4><0,.1,0> texture {T_Stone13}}
    box{<0,0,-4><4,.1,0>  texture {T_Stone11}}
    box{<-4,0,0><0,.1,4>  texture {T_Stone11}}
    box{<0,0,0><4,.1,4>   texture {T_Stone13}}
  }
}
    
              
#declare leiste = object{
union{
   difference {
      //box{<-2,-.5,-20>,<2,.5,20>}                                          
      prism {
        linear_sweep
        cubic_spline
        -20, // sweep the following shape from here ...
         20, // ... up through here
         18, // the number of points making up the shape ...
        <-1.5,-0.75>,<-2,-.5>,<-1.5,-.25>,<-1.2,0>,
        <0,0>,<.5,.2>,<0,.3>,<-.05,.4>, 
        <0.4,.5>,<2,.5>,<2,.5>,<2,.5>,<2,-.5>,
        <2,-.5>,<2,-.5>,<-2,-.5>,<-2,-.5>,<-2,-.5>
        rotate x*-90         
      } 
      box{<-2,.499,-21>,<3,1,21>}        
      box{<-5,-1,-5>,<5,1,5> rotate y*45 translate x*2 translate z* -23.15}
      box{<-5,-1,-5>,<5,1,5> rotate y*45 translate x*2 translate z*  23.15}
      texture {T_Wood7 scale 1.5 }  // 3 5 6 7! 10 11 13! 14! 18 19 20 23 24 29 34 35
      translate x*-18
   }     
  } 
  
}              
              
#declare brett = object{
  union{
      #declare px=0;
      #declare pz=0;
      #while (pz<4) 
        #while (px<4)
          object { quadro translate x * px*8 translate z * pz*8 }
          #declare px=px+1;
        #end
        #declare px=0;
        #declare pz=pz+1;
      #end 
      difference{
        union {
          object {leiste} 
          object {leiste rotate y*90}
          object {leiste rotate y*180}
          object {leiste rotate y*270}   
        }
        
        difference{
         union{   
          union{
            text { ttf "timrom.ttf" "A" 1, 0 translate y*.6 translate x*4}
            text { ttf "timrom.ttf" "B" 1, 0 translate y*.6 translate x*8}
            text { ttf "timrom.ttf" "C" 1, 0 translate y*.6 translate x*12}
            text { ttf "timrom.ttf" "D" 1, 0 translate y*.6 translate x*16}
            text { ttf "timrom.ttf" "E" 1, 0 translate y*.6 translate x*20}
            text { ttf "timrom.ttf" "F" 1, 0 translate y*.6 translate x*24}
            text { ttf "timrom.ttf" "G" 1, 0 translate y*.6 translate x*28}
            text { ttf "timrom.ttf" "H" 1, 0 translate y*.6 translate x*32}
            rotate y*90
            rotate z*-90
            translate x * -18
            translate z * 18.2
            translate y * .6
          } 
        
          union{
            text { ttf "timrom.ttf" "H" 1, 0 translate y*.6 translate x*4}
            text { ttf "timrom.ttf" "G" 1, 0 translate y*.6 translate x*8}
            text { ttf "timrom.ttf" "F" 1, 0 translate y*.6 translate x*12}
            text { ttf "timrom.ttf" "E" 1, 0 translate y*.6 translate x*16}
            text { ttf "timrom.ttf" "D" 1, 0 translate y*.6 translate x*20}
            text { ttf "timrom.ttf" "C" 1, 0 translate y*.6 translate x*24}
            text { ttf "timrom.ttf" "B" 1, 0 translate y*.6 translate x*28}
            text { ttf "timrom.ttf" "A" 1, 0 translate y*.6 translate x*32}
            rotate y*-90
            rotate z*90
            translate x * 18
            translate z * -18.2
            translate y * .6
          }   
        
          union{
            text { ttf "timrom.ttf" "1" 1, 0 rotate x* 90 translate y*.6 translate z*4}
            text { ttf "timrom.ttf" "2" 1, 0 rotate x* 90 translate y*.6 translate z*8}
            text { ttf "timrom.ttf" "3" 1, 0 rotate x* 90 translate y*.6 translate z*12}
            text { ttf "timrom.ttf" "4" 1, 0 rotate x* 90 translate y*.6 translate z*16}
            text { ttf "timrom.ttf" "5" 1, 0 rotate x* 90 translate y*.6 translate z*20}
            text { ttf "timrom.ttf" "6" 1, 0 rotate x* 90 translate y*.6 translate z*24}
            text { ttf "timrom.ttf" "7" 1, 0 rotate x* 90 translate y*.6 translate z*28}
            text { ttf "timrom.ttf" "8" 1, 0 rotate x* 90 translate y*.6 translate z*32}
            rotate y*90
            translate x * -18.5
            translate z * 17.2
            translate y * .05
          }    
        
          union{
            text { ttf "timrom.ttf" "1" 1, 0 rotate x* -90 translate y*.5 translate z*4}
            text { ttf "timrom.ttf" "2" 1, 0 rotate x* -90 translate y*.5 translate z*8}
            text { ttf "timrom.ttf" "3" 1, 0 rotate x* -90 translate y*.5 translate z*12}
            text { ttf "timrom.ttf" "4" 1, 0 rotate x* -90 translate y*.5 translate z*16}
            text { ttf "timrom.ttf" "5" 1, 0 rotate x* -90 translate y*.5 translate z*20}
            text { ttf "timrom.ttf" "6" 1, 0 rotate x* -90 translate y*.5 translate z*24}
            text { ttf "timrom.ttf" "7" 1, 0 rotate x* -90 translate y*.5 translate z*28}
            text { ttf "timrom.ttf" "8" 1, 0 rotate x* -90 translate y*.5 translate z*32}
            rotate y*90    
            rotate x*180
            translate x * -17.9
            translate z * -17.2
            translate y * 1.1
          }
         }
         box {<-19,.35,-19>,<19,-3,19>}
         pigment {rgb <1,1,1>}
        }                      
        translate x* 12 translate z*12 translate y * -.4
      }
        
  }
  translate x* -12 translate z* -12
}                           
       
       
       
#macro setfigure(XF,YF,Figur, White)
  object{ Figur texture { #if (White) T_Stone13 #else T_Stone11  #end } #if (!White) rotate y*180 #end translate x*((XF*4)-18) translate z* (((9-YF)*4)-18) }
#end
                                                                                                  
union {             
  object {brett}
  #declare bx=1;
  #while (bx<9)  
    setfigure(2,bx,bauer, 1)
    setfigure(7,bx,bauer, 0)     
    #declare bx=bx+1;
  #end
  
  setfigure(1,1,turm, 1)
  setfigure(1,8,turm, 1)
  setfigure(8,1,turm, 0)
  setfigure(8,8,turm, 0)
  
  setfigure(1,3,laeufer, 1)
  setfigure(1,6,laeufer, 1)
  setfigure(8,3,laeufer, 0)
  setfigure(8,6,laeufer, 0)
  
  setfigure(1,2,springer, 1)
  setfigure(1,7,springer, 1)
  setfigure(8,2,springer, 0)
  setfigure(8,7,springer, 0)  
  
  setfigure(1,4,dame, 1)
  setfigure(8,4,dame, 0)  
  
  setfigure(clock * 7 +1,5,king, 1)
  setfigure(8,5,king, 0)

  rotate y* 25    
  
}                    


/*
 * Schferzug in Povray-Notation:
 * 5/2 nach 5/4 Erster Zug: Knigsbauern (der vor dem Knig) ziehen!
 * 5/7 nach 5/5 Schwarz zieht
 * 6/1 nach 3/4 zweiter Zug: den Lufer neben dem Knig (von f1) vier Felder herausziehen (nach c4)!
 * 6/8 nach 5/7 Schwarz zieht
 * 4/1 nach 6/3 dritter Zug: Die Dame (von d1) entweder drei (nach f3) oder fnf (nach h5) Felder herausziehen! (zweiter und dritter Zug sind vertauschbar)
 * 1/7 nach 1/6 Schwarz zieht
 * 6/3 nach 6/7 vierter Zug: Die Dame setzt den schwarzen Knig auf dem Feld f7 (schrg vor dem Knig) matt. Partie ist beendet
 */       
